; wait stuff
;waits count for count <255
; just loads W with count, then calls doWait
;total instruction cycles 1+2+6+4*(count-1)=9+4*(count-1): 
; call DoWait count takes 2+6+4(count-1) 
; doWait uses WaitCtr
Wait    macro   count
	movlw   -count  ;1
	call    DoWait  ;2
	endm

; following two macros are to do a loop with a 16 bit count value.
; you init loop by calling InitBigLoop, which loads designated registers
; with low- and hi-order bytes of -count.
; to iterate loop, at end of loop you call
;       EndBigLoop Tag
; where Tag is a tag that marks start of loop.

InitBigLoop     macro   count
;macro to initialize big loop count
	movlw   low     (-count)        ;low byte in RegL
	movwf   Ctr1L
	movlw   high    (-count)        ;hi byte in RegH
	movwf   Ctr1H
	endm

EndBigLoop      macro   looptag
;macro to loop big count
	incf    Ctr1L,1    ; RegL is initially negtive of low-order bits in count,
			;   later on, gets inited to full 256
			; increment it
	btfsc   STATUS,2             ; if result zero,
	  incf  Ctr1H,1    ;   then increment hi-order byte
			; in any case, check if hi order byte has gone negative,
	btfss   STATUS,2     ; if it is nonzero,
	  goto  looptag ;   go back to start of entire loop
	endm            ; otherwise we're done
;----------------------------------------------------
DoWait  ; W holds -count
; cycles 1 + ((count-1)*(1+1+2)) +(1+2)       +2   = 6+4*(count-1) cycles
;      init       loop          end loop   return
; call DoWait count takes 2+6+4(count-1) instruction cycles = 1.6u + .8*(count-1) @ 20MHz
; count/PIC cycles/time(us)@20MHz
;   	1	8	1.6
;	2	12	2.4
;	3	16	3.2
;	4	20	4
;	10	24	9.6
;	255		200us
	
	movwf   waitctr 	; 1 cycle
waitloop
	incf    waitctr,F 	; 1 cycle
	btfss   STATUS,Z  	;if last result non-zero, do next, else skip
				; 1 cycle until last, then 2
	goto  	waitloop  	; 2 cycle
	return    ; 2 cyc 	; changed from retlw (for c554 and f84) 22 mar 99

